<template>
  <div>
    <div class="d-flex justify-content-end pb-3">
      <div>
        <b-button
          v-if="currentEditId"
          class="ml-auto mr-2"
          variant="success"
          @click="save"
        >
          <i class="flaticon2-check-mark"></i> Simpan
        </b-button>

        <b-button class="ml-auto" variant="success" @click="loadDesigns">
          Load Design
        </b-button>
      </div>
    </div>

    <complete-table :loading="loading" :data="items">
      <template #header>
        <tr class="text-left">
          <th></th>
          <th style="min-width: 250px" class="pl-7">
            <span class="text-dark-75">Numbering</span>
          </th>
          <th style="min-width: 300px">Title</th>
          <th style="min-width: 100px">Status</th>
          <th style="min-width: 100px">Revision</th>
          <th style="min-width: 100px">Version</th>
          <th style="min-width: 200px">Date Receive</th>
          <th style="min-width: 100px">Delay</th>
          <th style="min-width: 200px">Storage Ruang Doc</th>
          <th style="min-width: 100px">Server</th>
          <th style="min-width: 100px">Asbuilt</th>
          <th style="min-width: 150px">Return Item</th>
          <th style="min-width: 150px">Outstanding</th>
          <th style="min-width: 250px" class="text-center">Aksi</th>
        </tr>
      </template>

      <template #defaultBody="{ item, i }">
        <tr v-bind:key="i">
          <td>
            <button class="btn btn-default btn-xs" @click="setExpandedIndex(i)">
              <span class="flaticon-eye"></span>
            </button>
          </td>

          <td class="pl-0 ">
            <span
              class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
            >
              {{ item.numbering }}
            </span>
          </td>

          <td>
            <on-edit-row :is-edit="isEdit(item.id)">
              <template #onEdit>
                <input class="form-control" v-model="currentEditForm.title" />
              </template>

              <template #onView>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.title }}
                </span>
              </template>
            </on-edit-row>
          </td>

          <td>
            <on-edit-row :is-edit="isEdit(item.id)">
              <template #onEdit> </template>

              <template #onView>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.status }}
                </span>
              </template>
            </on-edit-row>
          </td>

          <td>
            <on-edit-row :is-edit="isEdit(item.id)">
              <template #onEdit>
                <input
                  class="form-control"
                  v-model="currentEditForm.revision_version"
                />
              </template>

              <template #onView>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.revision_version }}
                </span>
              </template>
            </on-edit-row>
          </td>

          <td>
            <on-edit-row :is-edit="isEdit(item.id)">
              <template #onEdit>
                <input class="form-control" v-model="currentEditForm.version" />
              </template>

              <template #onView>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.version }}
                </span>
              </template>
            </on-edit-row>
          </td>

          <td>
            <on-edit-row :is-edit="isEdit(item.id)">
              <template #onEdit>
                <input
                  class="form-control"
                  type="date"
                  v-model="currentEditForm.date_receive"
                />
              </template>

              <template #onView>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.date_receive }}
                </span>
              </template>
            </on-edit-row>
          </td>

          <td>
            <on-edit-row :is-edit="isEdit(item.id)">
              <template #onEdit>
                <input class="form-control" v-model="currentEditForm.delay" />
              </template>

              <template #onView>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.delay }}
                </span>
              </template>
            </on-edit-row>
          </td>

          <td>
            <on-edit-row :is-edit="isEdit(item.id)">
              <template #onEdit>
                <input
                  class="form-control"
                  v-model="currentEditForm.doc_room"
                />
              </template>

              <template #onView>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.doc_room }}
                </span>
              </template>
            </on-edit-row>
          </td>

          <td>
            <on-edit-row :is-edit="isEdit(item.id)">
              <template #onEdit>
                <input class="form-control" v-model="currentEditForm.server" />
              </template>

              <template #onView>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.server }}
                </span>
              </template>
            </on-edit-row>
          </td>

          <td>
            <on-edit-row :is-edit="isEdit(item.id)">
              <template #onEdit>
                <b-form-checkbox
                  class="mx-auto"
                  size="lg"
                  v-model="currentEditForm.monitoring_asbuilt_status"
                ></b-form-checkbox>
              </template>

              <template #onView>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.monitoring_asbuilt_status }}
                </span>
              </template>
            </on-edit-row>
          </td>

          <td>
            <on-edit-row :is-edit="isEdit(item.id)">
              <template #onEdit>
                <input
                  class="form-control"
                  v-model="currentEditForm.return_item"
                />
              </template>

              <template #onView>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.return_item }}
                </span>
              </template>
            </on-edit-row>
          </td>

          <td>
            <on-edit-row :is-edit="isEdit(item.id)">
              <template #onEdit>
                <b-form-select
                  v-model="currentEditForm.outstanding"
                  :options="formattedOutstandingOptions"
                  size="lg"
                ></b-form-select>
              </template>

              <template #onView>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.outstanding ? item.outstanding.name : null }}
                </span>
              </template>
            </on-edit-row>
          </td>

          <td class="pr-0">
            <div class="d-flex justify-content-center">
              <on-edit-row :is-edit="isEdit(item.id)">
                <template #onEdit>
                  <a
                    class="btn btn-light-danger font-weight-bolder font-size-sm"
                    @click="cancelEdit"
                  >
                    <i class="flaticon2-cancel-music"></i>
                  </a>
                </template>

                <template #onView>
                  <a
                    class="btn btn-light-primary font-weight-bolder font-size-sm mr-2"
                    @click="toEditPage()"
                  >
                    <i class="flaticon-refresh"></i>
                  </a>

                  <a
                    class="btn btn-light-success font-weight-bolder font-size-sm mr-2"
                    @click="editData(item)"
                  >
                    <i class="flaticon-edit"></i>
                  </a>

                  <a
                    class="btn btn-light-danger font-weight-bolder font-size-sm mr-2"
                    @click="openDeleteDialog(item)"
                  >
                    <i class="flaticon2-rubbish-bin-delete-button"></i>
                  </a>
                </template>
              </on-edit-row>
            </div>
          </td>
        </tr>

        <tr v-bind:key="i + 'detail'" v-if="expandedIndex === i">
          <td colspan="12">
            <template>
              <div>
                <div class="card p-5 gutter-b">
                  <div class="card-body p-0">
                    <div class="row">
                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                          >Type : </span
                        ><span class="text-dark-75">{{ optionalObject(item.type, "name") }}</span>
                      </div>

                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                        >
                          Stasiun :
                        </span>

                        <span class="text-dark-75">
                          {{ optionalObject(item.station, "name") }}
                        </span>
                      </div>

                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                          >Approved : </span
                        ><span class="text-dark-75">{{ item.approved }}</span>
                      </div>

                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                          >Planning Date : </span
                        ><span class="text-dark-75">{{
                          item.planning_date
                        }}</span>
                      </div>
                    </div>

                    <div class="row">
                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                          >Category : </span
                        ><span class="text-dark-75">{{ optionalObject(item.category, 'name') }}</span>
                      </div>

                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                          >Designer PIC : </span
                        ><span class="text-dark-75">
                          {{ optionalObject(item.designerPic, "code") }}</span
                        >
                      </div>

                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                          >Drafter PIC : </span
                        ><span class="text-dark-75">
                          {{ optionalObject(item.drafterPic, "code") }}</span
                        >
                      </div>

                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                          >Checker PIC : </span
                        ><span class="text-dark-75">
                          {{ optionalObject(item.checkerPic, "code") }}</span
                        >
                      </div>
                    </div>

                    <div class="row">
                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                          >Scope : </span
                        ><span class="text-dark-75">{{ optionalObject(item.scope, "name") }}</span>
                      </div>

                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                          >Designer Hour : </span
                        ><span class="text-dark-75">
                          {{ item.designerHour }}</span
                        >
                      </div>

                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                          >Drafter Hour : </span
                        ><span class="text-dark-75">{{
                          item.drafterHour
                        }}</span>
                      </div>

                      <div class="col-md-3 ">
                        <span
                          class="text-dark-75 font-weight-bolder font-size-lg"
                          >Checker Hour : </span
                        ><span class="text-dark-75">{{
                          item.checkerHour
                        }}</span>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </template>
          </td>
        </tr>
      </template>
    </complete-table>

    <v-dialog
      v-model="dialog"
      transition="dialog-top-transition"
      max-width="400"
    >
      <v-card>
        <v-card-title class="headline">Konfirmasi Hapus Data</v-card-title>

        <v-card-text>
          Apakah anda yakin ingin menghapus data
          <b>{{ this.currentItem ? this.currentItem.numbering : null }}</b> ?
        </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>

          <v-btn color="green darken-1" text @click="deleteItem">
            Hapus
          </v-btn>

          <v-btn color="green darken-1" text @click="dialog = false">
            Batal
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import CompleteTable from "../../../content/widgets/advance-table/CompleteTable";
import {
  DELETE_DL_DESIGN,
  UPDATE_DL_DESIGN
} from "../../../../core/services/store/dl.design.module";
import OnEditRow from "../../../content/widgets/advance-table/row/OnEditRow";
import { mapState } from "vuex";
import { GET_OUTSTANDING } from "../../../../core/services/store/outstanding.module";
import { optionalData } from "../../../../core/helper/object-validation.helper";

export default {
  name: "TabContent",
  components: {
    OnEditRow,
    CompleteTable
  },
  props: {
    loading: {
      default: true,
      type: Boolean
    },
    items: {
      default: () => [],
      type: Array
    },
    designType: {
      require: true,
      default: "DOC",
      type: String
    },
    project: {
      required: false,
      default: () => {}
    }
  },
  computed: {
    ...mapState({
      outstanding: state => state.outstanding.outstanding?.data
    }),

    formattedOutstandingOptions() {
      let outstanding = [];

      if (this.arrayMoreThanOne(this.outstanding)) {
        outstanding = this.outstanding.map(scope => {
          return {
            value: scope.code,
            text: scope.name
          };
        });
      }

      return [{ value: null, text: "Pilih Outstanding" }, ...outstanding];
    }
  },
  data() {
    return {
      expandedIndex: null,
      currentItem: null,
      dialog: false,
      currentEditId: null,
      currentEditForm: {
        title: null,
        status: null,
        revision_version: null,
        version: null,
        date_receive: null,
        delay: null,
        doc_room: null,
        server: null,
        monitoring_asbuilt_status: null,
        return_item: null,
        outstanding: "project"
      }
    };
  },
  mounted() {
    this.$store.dispatch(GET_OUTSTANDING, {});
  },
  methods: {
    setExpandedIndex(index) {
      if (this.expandedIndex === index) {
        this.expandedIndex = null;
      } else {
        this.expandedIndex = index;
      }
    },

    openDeleteDialog(item) {
      this.currentItem = item;
      this.dialog = true;
    },

    optionalObject(object, key) {
      return optionalData(object, key);
    },

    toEditPage() {
      //
    },

    editData(item) {
      this.currentEditId = item.id;

      this.currentItem = item;

      this.currentEditForm = {
        title: item.title,
        status: item.status,
        revision_version: item.revision_version,
        version: item.version,
        date_receive: item.date_receive,
        delay: item.delay,
        doc_room: item.doc_room,
        server: item.server,
        monitoring_asbuilt_status: item.monitoring_asbuilt_status,
        return_item: item.return_item,
        outstanding: item.outstanding?.code
      };
    },

    cancelEdit() {
      this.currentEditId = null;

      this.currentItem = null;

      this.currentEditForm = {
        title: null,
        status: null,
        revision_version: null,
        version: null,
        date_receive: null,
        delay: null,
        doc_room: null,
        server: null,
        monitoring_asbuilt_status: null,
        return_item: null,
        outstanding: null
      };
    },

    loadDesigns() {
      this.$emit("loadDesigns", this.designType);
    },

    isEdit(id) {
      return id === this.currentEditId;
    },

    deleteItem() {
      this.dialog = false;

      this.$store.dispatch(DELETE_DL_DESIGN, {
        data: {
          project: {
            code: this.project?.code,
            nickname: this.project?.nickname
          },
          designs: [this.currentItem.id]
        }
      });
    },

    save() {
      const outstanding = this.formattedOutstandingOptions.find(
        item => item.value === this.currentEditForm.outstanding
      );

      this.$store
        .dispatch(UPDATE_DL_DESIGN, {
          dld: [
            {
              id: this.currentEditId,
              title: this.currentEditForm.title,
              last_status: {
                code: "A",
                name: "original"
              },
              revision_version: this.currentEditForm.revision_version,
              version: this.currentEditForm.version,
              date_receive: this.currentEditForm.date_receive,
              delay: this.currentEditForm.delay,
              doc_room: this.currentEditForm.doc_room,
              server: this.currentEditForm.server,
              monitoring_asbuilt_status: this.currentEditForm
                .monitoring_asbuilt_status,
              return_item: this.currentEditForm.return_item,
              outstanding: this.currentEditForm.outstanding
                ? {
                    code: outstanding.value,
                    drafter: outstanding.text
                  }
                : null,
              obselete: 0
            }
          ]
        })
        .then(() => {
          this.cancelEdit();
        });
    },

    arrayMoreThanOne(array) {
      return array?.length > 0;
    }
  }
};
</script>
